/*
 * {app} - {purpose, description}
 *
 * Copyright (c) 2005-2009 Rack-Soft, LLC. All rights reserved.
 *
 * $Header: //itsd/devel/platform/voipnow/251/low_level/kamailio_extra_sources/1.5.4/4psa_mem_wrappers.h#1 $
 *
 * Modified: $DateTime: 2010/09/28 18:16:02 $ by $Author: bogdanc $ with $Change: 71991 $
 */



#ifndef MEM_WRAPPER_H__
#define MEM_WRAPPER_H__

#include <stdlib.h>

static inline void *malloc_f(size_t s) {
	return pkg_malloc(s);
}

static inline void free_f(void *p) {
	pkg_free(p);
}

static inline void *calloc_f(size_t nelem, size_t elsize) {
	void *p = pkg_malloc(nelem * elsize);
	if (p) memset(p, 0, nelem * elsize);
	return p;
}

static inline void *realloc_f(void *p, size_t s) {
	return pkg_realloc(p, s);
}

static inline void *shm_malloc_f(size_t s) {
	return shm_malloc(s);
}

static inline void shm_free_f(void *p) {
	shm_free(p);
}

static inline void *shm_calloc_f(size_t nelem, size_t elsize) {
	void *p = shm_malloc(nelem * elsize);
	if (p) memset(p, 0, nelem * elsize);
	return p;
}

static inline void *shm_realloc_f(void *p, size_t s) {
	return shm_realloc(p, s);
}



#endif /* MEM_WRAPPER_H__ */
