<?xml version="1.0"?>

<!--
 * $Id: module-man.xsl 5856 2009-05-25 12:41:55Z henningw $
 *
 * XSL converter script for man pages
 *
 * Copyright (C) 2009 1&1 Internet AG
 *
 * This file is part of Kamailio, a free SIP server.
 *
 * Kamailio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * Kamailio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
-->


<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml"   
    ident="no"   omit-xml-declaration="yes"/>

<!--Here we start building the manpage
    This matches the root element-->
<xsl:template match="/">
<xsl:apply-templates/>

.SH AUTHORS

see 
.B /usr/share/doc/kamailio/AUTHORS

.SH SEE ALSO
.BR kamailio(8), 
.BR kamailio.cfg(5)
.PP
Full documentation on Kamailio is available at
.I http://www.kamailio.org/.
.PP
Mailing lists:
.nf 
users@lists.kamailio.org - Kamailio user community
.nf 
devel@lists.kamailio.org - Kamailio development, new features and unstable version
</xsl:template>

<!--Generating the title of the Manpage -->
<xsl:template match="/book/bookinfo/title">
.TH <xsl:value-of select="translate(., ' ', '-')"/> 8
.SH NAME                                                            
<xsl:value-of select="translate(., ' ', '-')"/> \- <xsl:value-of select="."/> for Kamailio
</xsl:template>

<!--Here we generate the sections of the manpage-->
<xsl:template match="/book/chapter/section/title">
.SH <xsl:value-of select="."/>

</xsl:template>

<xsl:template match="/book/chapter/section/section/title">
.TP 16
.I <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="para">
.TP
<xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="example/title">
.TP
.B <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="programlisting">
.TP
<xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="@*|text()"/>

</xsl:stylesheet>
