/*
 * {app} - {purpose, description}
 *
 * Copyright (c) 2005-2006 Rack-Soft, LLC. All rights reserved.
 *
 * $Header: //itsd/devel/platform/voipnow/251/low_level/kamailio_extra_sources/1.5.4/modules/avpops/avpops_4psa.h#1 $
 *
 * Modified: $DateTime: 2010/09/28 18:16:02 $ by $Author: bogdanc $ with $Change: 71991 $
 */


#ifndef _AVP_OPS_4PSA_H_
#define _AVP_OPS_4PSA_H_

#include "../../dprint.h"


static int fixup_checklocalip_avps(void** param, int param_no) {
	if (db_url.s==0)
	{
		LM_ERR("you have to configure db_url for using avp_db_query function\n");
		return E_UNSPEC;
	}

	/* parse param into an pv_elem_t for each argument (no matter param_no) */
	return fixup_db_query_avp(param, 1);
}

static int fixup_comasplit_avp(void** param, int param_no) {
	if (db_url.s==0)
	{
		LM_ERR("you have to configure db_url for using avp_db_query function\n");
		return E_UNSPEC;
	}

	if (param_no == 2 || param_no == 3) {
		return fixup_db_query_avp(param, 2);
	}

	return 0;
}

/* static int fixup_mem_query_avp(void** param, int param_no) {{{ */
static int fixup_mem_query_avp(void** param, int param_no) {
	struct db_redq_pair_t * memkeys = NULL;

	if (db_url.s==0)
	{
		LM_ERR("you have to configure db_url for using avp_db_query function\n");
		return E_UNSPEC;
	}
	
	switch (param_no) {
		case 1:
		if(!*param) {
			LM_ERR("null format in P%d\n", param_no);
			return E_UNSPEC;
		}
		LM_DBG("param 1");
		parse_redis_keys(*param, &memkeys, 0);
		if (memkeys == NULL) {
			LM_WARN("Could not successfully parse redis keys\n");
			return E_UNSPEC;
		}
		*param = (void *)memkeys;
		break;

		case 2:
		LM_DBG("param 2");
		return fixup_db_query_avp(param, 1);

		case 3:
		LM_DBG("param 3");
		return fixup_db_query_avp(param, 2);

		/* leave alone; we convert string to number later */
		case 4:
		LM_DBG("param 4");
		break;
	}

	return 0;
} /* fixup_mem_query_avp }}} */


/* static int fixup_mem_query_set_avp(void** param, int param_no) {{{ */
static int fixup_mem_query_set_avp(void** param, int param_no) {
	struct db_redq_pair_t * memkeys = NULL;

	if (db_url.s==0)
	{
		LM_ERR("you have to configure db_url for using avp_db_query function\n");
		return E_UNSPEC;
	}
	
	switch (param_no) {
		case 1:
		if(!*param) {
			LM_ERR("null format in P%d\n", param_no);
			return E_UNSPEC;
		}
		LM_DBG("param 1");
		parse_redis_keys(*param, &memkeys, 1);
		if (memkeys == NULL) {
			LM_WARN("Could not successfully parse redis keys\n");
			return E_UNSPEC;
		}
		*param = (void *)memkeys;
		break;

		case 2:
		LM_DBG("param 2");
		return fixup_db_query_avp(param, 1);

		case 3:
		LM_DBG("param 3");
		return fixup_db_query_avp(param, 2);

		/* leave alone; we convert string to number later */
		case 4:
		LM_DBG("param 4");
		break;
	}

	return 0;
} /* fixup_mem_query_set_avp }}} */


static int w_memquery1_avps(struct sip_msg* msg, char* memkeys, char* query)
{
	return ops_memquery_avps ( msg, (pv_elem_t*)query, 0\
			, (struct db_redq_pair_t *)memkeys, 0);
}

static int w_memquery2_avps(struct sip_msg* msg, char* memkeys, char* query\
		, char * dest, char * ttl)
{
	return ops_memquery_avps ( msg, (pv_elem_t*)query, (pvname_list_t*)dest\
			, (struct db_redq_pair_t *)memkeys, strtoul(ttl, NULL, 10));
}


static int w_comasplit_avps(struct sip_msg* msg, char* src, char* n, char * dest) {
	return ops_comasplit_avps(msg, src, (pvname_list_t*)n, (pvname_list_t*)dest);
}

static int w_checklocalip_avps(struct sip_msg* msg, char* ip1, char* ip2, char * mask) {
	return ops_checklocalip_avps(msg, (pv_elem_p)ip1, (pv_elem_p)ip2, (pv_elem_p)mask);
}

#endif /* _AVP_OPS_4PSA_H_ */
