/*
 * {app} - {purpose, description}
 *
 * Copyright (c) 2005-2009 Rack-Soft, LLC. All rights reserved.
 *
 * $Header: //itsd/devel/platform/voipnow/251/low_level/kamailio_extra_sources/1.5.4/modules/cache/cache_api.c#1 $
 *
 * Modified: $DateTime: 2010/09/28 18:16:02 $ by $Author: bogdanc $ with $Change: 71991 $
 */



#include <libredis/redis.h>
#include "cache.h"
#include "cache_api.h"


redis_return_t cache_get(char *key, size_t key_size, char **val, size_t *val_size) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler) goto _end;

	ret = redis_get(cache_handler, key, key_size, val, val_size);

_end:
	return ret;

}

redis_return_t cache_set(char *key, size_t key_size, char *val, size_t val_size, size_t ttl) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler) goto _end;

	ret = redis_set(cache_handler, key, key_size, val, val_size, ttl);

_end:
	return ret;

}

redis_return_t cache_inc(char *key, size_t key_size, int *incremented_value) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler) goto _end;

	ret = redis_incr(cache_handler, key, key_size, incremented_value);

_end:
	
	return ret;
}

redis_return_t cache_incby(char *key, size_t key_size, long by, int *incremented_value) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler) goto _end;

	ret = redis_incrby(cache_handler, key, key_size, by, incremented_value);

_end:
	
	return ret;
}

redis_return_t cache_dec(char *key, size_t key_size, int *decremented_value) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler) goto _end;

	ret = redis_decr(cache_handler, key, key_size, decremented_value);

_end:
	
	return ret;
}

redis_return_t cache_decby(char *key, size_t key_size, long by, int *decremented_value) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler) goto _end;

	ret = redis_decrby(cache_handler, key, key_size, by, decremented_value);

_end:
	
	return ret;
}

redis_return_t cache_del(char *key, size_t key_size) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler || !key) goto _end;

	ret = redis_del(cache_handler, key, key_size);

_end:
	
	return ret;
}

redis_return_t cache_sadd(char *key, size_t key_size, char *val, size_t val_size) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler || !key || !val) goto _end;

	ret = redis_sadd(cache_handler, key, key_size, val, val_size);
_end:
	
	return ret;
}

redis_return_t cache_srem(char *key, size_t key_size, char *val, size_t val_size) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler || !key || !val) goto _end;

	ret = redis_srem(cache_handler, key, key_size, val, val_size);

_end:
	
	return ret;

}

redis_return_t cache_scard(char *key, size_t key_size, int *card) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler || !key || !card) goto _end;

	ret = redis_scard(cache_handler, key, key_size, (unsigned *)card);

_end:
	
	return ret;

}

redis_return_t cache_sismember(char *key, size_t key_size, char *val, size_t val_size) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler || !key || !val) goto _end;

	ret = redis_sismember(cache_handler, key, key_size, val, val_size);

_end:
	
	return ret;

}

redis_return_t cache_smembers(char *key, size_t key_size, char ***val, size_t *val_len, \
								size_t **ind_val_len) {

	redis_return_t ret = REDIS_RET_ERROR;

	if (!cache_handler || !key || !val || !val_len || !ind_val_len) goto _end;

	ret = redis_smembers(cache_handler, key, key_size, val, val_len, ind_val_len);

_end:
	
	return ret;

}

