/*
 * 4PSA VoipNow - Binding structure and api
 * 
 * Copyright (c) 2005-2009 Rack-Soft, LLC. All rights reserved.
 *
 * $Header: //itsd/devel/platform/voipnow/251/low_level/kamailio_extra_sources/1.5.4/modules/cache/cache_bind.h#1 $
 *
 * Modified: $DateTime: 2010/09/28 18:16:02 $ by $Author: bogdanc $ with $Change: 71991 $
 */


#ifndef CACHE_BIND_H__
#define CACHE_BIND_H__

#include <libredis/redis.h>


/* Function types used in the API structure */
typedef redis_return_t (*cache_get_t)(char *key, size_t key_size, char **val, size_t *val_size);
typedef redis_return_t (*cache_set_t)(char *key, size_t key_size, char *val, size_t val_size, \
	size_t ttl);
typedef redis_return_t (*cache_inc_t)(char *key, size_t key_size, int *incval);
typedef redis_return_t (*cache_incby_t)(char *key, size_t key_size, long by, int *incval);
typedef redis_return_t (*cache_dec_t)(char *key, size_t key_size, int *decval);
typedef redis_return_t (*cache_decby_t)(char *key, size_t key_size, long by, int *decval);
typedef redis_return_t (*cache_del_t)(char *key, size_t key_size);
typedef redis_return_t (*cache_sadd_t)(char *key, size_t key_size, char *val, size_t val_len);
typedef redis_return_t (*cache_srem_t)(char *key, size_t key_size, char *val, size_t val_len);
typedef redis_return_t (*cache_scard_t)(char *key, size_t key_size, int *card);
typedef redis_return_t (*cache_sismember_t)(char *key, size_t key_size, char *val, \
	size_t val_size);
typedef redis_return_t (*cache_smembers_t)(char *key, size_t key_size, char ***val, \
	size_t *val_len, size_t **ind_val_len);


/* API structure */
typedef struct cache_api {
	
	cache_get_t 		get;
	cache_set_t 		set;
	cache_inc_t 		inc;
	cache_incby_t 		incby;
	cache_dec_t 		dec;
	cache_decby_t 		decby;
	cache_del_t			del;
	cache_sadd_t		sadd;
	cache_srem_t		srem;
	cache_scard_t		scard;
	cache_sismember_t	sismember;
	cache_smembers_t	smembers;

} cache_api_t;


/* Binding type and function */
typedef int (*bind_cache_t)(cache_api_t* api);
int bind_cache(cache_api_t* api);


#endif /* CACHE_BIND_H__ */
