/*
 * {app} - {purpose, description}
 *
 * Copyright (c) 2005-2006 Rack-Soft, LLC. All rights reserved.
 *
 * $Header: //itsd/devel/platform/voipnow/251/low_level/kamailio_extra_sources/1.5.4/modules/load_balancer/lb_prober.h#1 $
 *
 * Modified: $DateTime: 2010/09/28 18:16:02 $ by $Author: bogdanc $ with $Change: 71991 $
 */



#ifndef LB_PROBER_H__
#define LB_PROBER_H__

#define LB_DB_STATE_ACTIVE 1
#define LB_DB_STATE_PROBING 4
#define LB_DB_STATE_DISABLED 0

struct lb_node_list_t;

struct lb_node_list_t {
	/* this is the unique key from database */
	str nodeid;

	/* the destination from gateway cloud; the most usefull field for gateway */
	str dst_uri;

	struct lb_node_list_t * next;

	/* the advertized state of the node */
	int state;

	/* the state the node appears to have from pinging;
	 * if this reoccurs enough times advertize this state */
	int growing_state;

	/* the number of consecutive identical states */
	int state_counter;

	/* means to mark list elements */
	int recent;
};

#define NODE_LIST_LOCK
#define NODE_LIST_UNLOCK
//#define NODE_LIST_LOCK lock_get(g_node_list_lock )
//#define NODE_LIST_UNLOCK lock_release(g_node_list_lock )

extern gen_lock_t * g_node_list_lock;
extern struct lb_node_list_t * g_nodes;
extern str lb_ping_method;
extern str lb_ping_from;

void lb_check_timer(unsigned int ticks, void* param);
struct lb_node_list_t * lb_node_list_init(const char * nodeid, int nodeid_len, const char * dst, int dst_len, int state);

#endif /* LB_PROBER_H__ */
