/*
 * Function to send a PUBLISH every time the state of a user is changed in the ser_location table
 */

#define _GNU_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libxml/parser.h>
#include <time.h>
#include <values.h>

#include "../../dprint.h"	
#include "../usrloc/ul_callback.h"
#include "../pua/pua.h"
#include "pua_dialoginfo.h"

extern struct redis_client * g_puadlg_mem;

void ul_publish(ucontact_t* c, int type, void* param)
{
	str callid = str_init("dummy");
	str uri = {NULL, 0};
	char* at = NULL;	
	
	uri.s = (char*)pkg_malloc(sizeof(char)*(c->aor->len+default_domain.len+6));
	if(uri.s == NULL)
		goto error;

	memcpy(uri.s, "sip:", 4);
	uri.len = 4;
	memcpy(uri.s+ uri.len, c->aor->s, c->aor->len);
	uri.len+= c->aor->len;
	at = memchr(c->aor->s, '@', c->aor->len);
	if(!at)
	{
		uri.s[uri.len++]= '@';
		memcpy(uri.s+ uri.len, default_domain.s, default_domain.len);
		uri.len+= default_domain.len;		
	}

	uri.s[uri.len] = '\0';
	LM_DBG("\nul_publish: Publishing usrloc-based state for %s \n",uri.s);
	
	if (type & UL_CONTACT_EXPIRE || type & UL_CONTACT_DELETE) 
		dialog_publish("confirmed", &uri, &(c->c), &callid, 0, MAXINT - 3600 - (int)time(NULL), 0, 0, ST_OFFLINE_S);
	else 
		dialog_publish("terminated", &uri, &(c->c), &callid, 0, MAXINT - 3600 - (int)time(NULL), 0, 0, ST_REGISTER_S);

error:

	if(uri.s)
		pkg_free(uri.s);

	return;
}
