/*
 * 4PSA VoipNow - Implements a PV module constant. API for
 *                adding a constant to the PV cntset and
 *                getting it's value.
 *
 * Copyright (c) 2009 Rack-Soft, LLC. All rights reserved..
 *
 * $Header: //itsd/devel/platform/voipnow/251/low_level/kamailio_extra_sources/1.5.4/modules/pv/pv_cntv_4psa.h#1 $
 *
 * Modified: $DateTime: 2010/09/28 18:16:02 $ by $Author: bogdanc $ with $Change: 71991 $
 */

#ifndef _PV_CNTV_4PSA_H_
#define _PV_CNTV_4PSA_H_

#include "../../sr_module.h"
#include "pv_svar.h"

/* Internal structure to hold constant defintion */
typedef struct cnt_var {
	int n;                  /* Index of the variable */
	str name;               /* Name of the variable  */
	script_val_t v;         /* Value of the variable */
	struct cnt_var *next;   /* Entry into the global list of constants */
} cnt_var_t, *cnt_var_p;

/* adding the constant value and name - one time only per constat */
int param_set_cntvar(modparam_t type, void* val);

/* checks if a certain PVT_CONST spec variable is already defined */
int pv_parse_cntvar_name(pv_spec_p sp, str *in);

/* gets the value associated with the param PVT_CONST variable */
int pv_get_cntvar(struct sip_msg *msg,  pv_param_t *param, pv_value_t *res);

#endif
