/*
 * $Id: parse_from.h 4720 2008-08-23 10:56:15Z henningw $
 *
 * Copyright (C) 2001-2003 FhG Fokus
 *
 * This file is part of Kamailio, a free SIP server.
 *
 * Kamailio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * Kamailio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*!
 * \file
 * \brief Parse from header
 * \ingroup parser
 */

#ifndef _PARSE_FROM_H
#define _PARSE_FROM_H

#include "msg_parser.h"


/*! casting macro for accessing From body */
#define get_from(p_msg)  ((struct to_body*)(p_msg)->from->parsed)

#define free_from(_to_body_)  free_to(_to_body_)


/*!
 * From header field parser
 */
int parse_from_header( struct sip_msg *msg);

struct sip_uri *parse_from_uri(struct sip_msg *msg);

#endif
