/*
 * $Id: parse_refer_to.h 4720 2008-08-23 10:56:15Z henningw $
 *
 * Copyright (C) 2005 Juha Heinanen
 *
 * This file is part of Kamailio, a free SIP server.
 *
 * Kamailio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * Kamailio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*!
 * \file
 * \brief Refer-To header parser
 * \ingroup parser
 */

#ifndef PARSE_REFER_TO_H
#define PARSE_REFER_TO_H

#include "msg_parser.h"


/*! casting macro for accessing Refer-To body */
#define get_refer_to(p_msg)  ((struct to_body*)(p_msg)->refer_to->parsed)


/*!
 * This method is used to parse Refer-To header.
 * \param msg sip msg
 * \return 0 on success,-1 on failure.
 */
int parse_refer_to_header( struct sip_msg *msg);
 
#endif /* PARSE_REFER_TO_H */
