/*
 * {app} - {purpose, description}
 *
 * Copyright (c) 2005-2006 Rack-Soft, LLC. All rights reserved.
 *
 * $Header: //itsd/devel/platform/voipnow/251/low_level/kamailio_extra_sources/1.5.4/pvar_4psa.c#1 $
 *
 * Modified: $DateTime: 2010/09/28 18:16:02 $ by $Author: bogdanc $ with $Change: 71991 $
 */



#define _GNU_SOURCE

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <unistd.h>

/*
#include "mem/shm_mem.h"
#include "trim.h"
#include "dset.h"
#include "action.h"
#include "socket_info.h"
#include "route_struct.h"
#include "usr_avp.h"
#include "errinfo.h"
#include "transformations.h"
#include "script_var.h"
*/

#include <4psa_string.h>
#include "dprint.h"
#include "mem/mem.h"
#include "ut.h"
#include "pvar.h"

#define _trace __FILE__":%s:%d\n", __func__, __LINE__

#include "db/db_val.h"


/* db_type_t str2dbtype(const char * str) {{{ */
db_type_t str2dbtype(const char * str) {
	if (strcmp(str, "DB_INT") == 0) {
		return DB_INT;
	} else if (strcmp(str, "DB_DOUBLE") == 0) {
		return DB_DOUBLE;
	} else if (strcmp(str, "DB_STRING") == 0) {
		return DB_STRING;
	} else if (strcmp(str, "DB_STR") == 0) {
		return DB_STR;
	} else if (strcmp(str, "DB_DATETIME") == 0) {
		return DB_DATETIME;
	} else if (strcmp(str, "DB_BLOB") == 0) {
		return DB_BLOB;
	} else if (strcmp(str, "DB_BITMAP") == 0) {
		return DB_BITMAP;
	}

	/* FIXME - should return error here somehow */
	return 0;
} /* str2dbtype }}} */


static inline char* trim_front(char* toParse, char expected, char* notToSkip)
{
	char current;
	char notskip = (notToSkip)? *notToSkip : '\0';
	while (*toParse) {
		current = *toParse;
		if (current == ' ' || current == '\t') {
			*toParse = '\0';
		} else if ((current == expected) || (current == notskip)) {
			if (notToSkip) *notToSkip = *toParse;
			*toParse = '\0';
			return toParse;
		}
		toParse++;
	}
	return NULL;	
}

/* int parse_redis_keys(const char * param, struct db_redq_pair_t ** pkeys, unsigned char isSetType)) {{{ */
int parse_redis_keys(const char * param, struct db_redq_pair_t ** pkeys, unsigned char isSetType) {
#define PARSE_MEMKEY_MAXSZ 20
	int parseState, len, n, ret = -1;
	char *toParse, *toEnd, *toFree = NULL;
	struct db_redq_pair_t * keys = NULL;

	if (!param || !*param) {
		LM_ERR("Argument syntax error.");
		goto _end;
	}
	
	len = strlen(param);
	toFree = toParse = pkg_malloc((len + 1) * sizeof(char));
	memcpy(toParse, param, (len + 1) * sizeof(char));

	n = -1;
	parseState = 0;

	LM_DBG("fixup:%s\n", toParse);
	
	/*  <extension.$var(tu) | 0 | DB_INT > or for set <extension.$var(tu) | $si | 0 | DB_INT | FLAG> */
	while (toParse && *toParse) {
		switch (parseState) {
		case 0: {
			if ((toParse = trim_front(toParse, '<', NULL)) == NULL)
				break; /* we are done */
			
			n++;
			keys = pkg_realloc(keys, (n + 2) * sizeof(struct db_redq_pair_t));
			keys[n + 1].memkey = NULL;
			keys[n].memkey = NULL;
			keys[n].setkey = NULL;
			keys[n].flag   = 0;
			
			parseState = 1;
			toParse++;
			continue;
		}
		case 1: {/* memkey */
			char *endKey;
			if ((toEnd = trim_front(toParse, '|', NULL)) == NULL)
				goto _end;
			while(!*toParse) toParse++;
			endKey = toEnd;
			while (!*endKey) endKey--;
			endKey++;
			
			len = endKey - toParse + 1;
			keys[n].memkey = malloc(len);
			memcpy(keys[n].memkey , toParse, len);

			toParse = toEnd + 1;
			parseState = (isSetType)? 2 : 3;
			continue;
		}
		case 2: {/* $si */
			char *endKey;
			if ((toEnd = trim_front(toParse, '|', NULL)) == NULL)
				goto _end;
			while(!*toParse) toParse++;
			endKey = toEnd;
			while (!*endKey) endKey--;
			endKey++;
						
			len = endKey - toParse + 1;
			keys[n].setkey = malloc(len);
			memcpy(keys[n].setkey , toParse, len);
						
			toParse = toEnd + 1;
			parseState = 3;
			continue;
		}
		case 3: /* col */
			if ((toEnd = trim_front(toParse, '|', NULL)) == NULL)
				goto _end;
			while(!*toParse) toParse++;

			if ((keys[n].col = strtol(toParse, NULL, 10)) < 0)
				goto _end;

			toParse = toEnd + 1;
			parseState = 4;
			continue;
		case 4: {/* DB_TYPE */
			char notSkip = '>';
			if ((toEnd = trim_front(toParse, '|', &notSkip)) == NULL)
				goto _end;
			while(!*toParse) toParse++;

			keys[n].type = str2dbtype(toParse);
			
			toParse = toEnd + 1;
			parseState = (notSkip == '>')? 0 : 5;
			continue;
		}
		case 5: /* FLAG */
			if ((toEnd = trim_front(toParse, '>', NULL)) == NULL)
				goto _end;
			while(!*toParse) toParse++;

			if ((keys[n].flag = strtoul(toParse, NULL, 10)) > 5)
				goto _end;
						
			toParse = toEnd + 1;
			parseState = 0;
			continue;
		}
	}

	*pkeys = keys;
	ret = 0;
_end:
	if (ret == -1) {
		LM_WARN("Could not correctly parse memkey value %s\n", param);
		if (keys) {
			int i;
			for (i = 0; keys[i].memkey; ++i) {
				free(keys[i].memkey);
				free(keys[i].setkey);
			}
			pkg_free(keys);
		}
		*pkeys = NULL;
	}
	pkg_free(toFree);

	return ret;
} /* parse_redis_keys }}} */


/* int get_pv_val(struct sip_msg* msg, const char * name, pv_value_p pv_val) {{{ */
int get_pv_val(struct sip_msg* msg, const char * name, pv_value_p pv_val) {
	int ret = -1;
	str ss;
	pv_spec_t spec;

	ss.s = (char *)name;
	ss.len = strlen(name);

	if (!pv_parse_spec(&ss, &spec)) goto _end;

	ret = pv_get_spec_value(msg, &spec, pv_val);

_end:

	return ret;
} /* get_pv_val }}} */


/* int expand_pv(struct sip_msg* msg, char ** memkey) {{{ */
int expand_pv(struct sip_msg* msg, char ** memkey, char split_ch, char ** save, int alloc_type) {
	int ret = -1;
	int i = 0;
	pv_value_t pv_val;
	safestr_t * spl = NULL;
	safestr_t safe_fmt = safestr_create("%d", 0);
	safestr_t tmp = NULL;
	int has_pv = 0;

	/* LM_DBG("memkey start:%s\n", *memkey); */
	bzero(&pv_val, sizeof(pv_val));
	spl = safestr_split_bychar(SAFESTR_TEMP(*memkey), split_ch);
	if (!spl) goto _end;

	do {
		LM_DBG("raw name:%s\n", (const char *)spl[i]);
		if (((const char *)spl[i])[0] != PV_MARKER) continue;
		has_pv = 1;

		if (get_pv_val(msg, (const char *)spl[i], &pv_val) != 0) goto _end;

		if (pv_val.flags & PV_VAL_NONE || pv_val.flags & PV_VAL_NULL) goto _end;

		if (! (pv_val.flags & PV_VAL_STR)) {
			LM_DBG("avp val:i:%d\n", pv_val.ri);
			safestr_sprintf(&spl[i], safe_fmt, pv_val.ri);
		} else {
			char * stupid_tmp = NULL;

			/* the result is thier (stupid) str struct
			 * the char * there is not \0 term and we can't add noe
			 * since it will be invalid write, hence the stupid data copy */
			stupid_tmp = malloc(pv_val.rs.len + 1);
			if (!stupid_tmp) goto _end;

			memcpy(stupid_tmp, pv_val.rs.s, pv_val.rs.len);
			stupid_tmp[pv_val.rs.len] = '\0';

			LM_DBG("avp val:s:%s\n", stupid_tmp);

			safestr_free(spl[i]);
			spl[i] = safestr_create(stupid_tmp, 0);
			free(stupid_tmp);
		}

		LM_DBG("avp:%s (%d)\n", (const char *)spl[i], safestr_length(spl[i]));

	} while (spl[++i]);


	if (has_pv) {
		tmp = safestr_join_bychar(spl, split_ch);
		if (!tmp) goto _end;

		switch (alloc_type) {
			case ALLOC_GLIBC:
			if (save) *save = *memkey;
			else free(*memkey);
			*memkey = strdup((const char *)tmp);

			break;

			case ALLOC_PKG:
			if (save) *save = *memkey;
			else pkg_free(*memkey);
			*memkey = pkg_malloc(safestr_length(tmp)+1);
			memcpy(*memkey, (const char *)tmp, safestr_length(tmp));
			(*memkey)[safestr_length(tmp)] = '\0';
			break;
		}
	}

	ret = 0;
_end:
	if (save && *save) LM_DBG("saved: %s", *save);
	if (tmp) safestr_free(tmp);
	if (safe_fmt) safestr_free(safe_fmt);
	if (spl) safestr_freelist(spl);

	return ret;
} /* expand_pv }}} */


/* int get_pv_cnt(const char *name, pv_value_p pv_val) {{{ */
char* get_pv_cnt(const char *name, pv_value_p pv_val) {
	char* over = 0;
	str ss;
	pv_spec_t spec;

	ss.s   = (char *)name;
	ss.len = strlen(name);

	if ((over = pv_parse_spec(&ss, &spec)) == 0) goto _end;

	if (spec.type == PVT_CONST) {
		memset(pv_val, 0, sizeof(pv_value_t));
		(*spec.getf)((struct sip_msg*)0, &spec.pvp, pv_val);
	} else {
		over = 0;
	}

_end:
	return over;
} /* get_pv_cnt }}} */


/* int expand_pv_cnt(const char *original, char **expanded) {{{ */
int expand_pv_cnt(const char *original, char **expanded)
{
static char max_expanded[256];
	pv_value_t pv_val;
	const char *last  = original;
	const char *over  = 0;
	char *p     = max_expanded;
	int current = 0;

	if (!original || !*original)
		return 0;

	do {
		if (*original != PV_MARKER) {
			original++;
			current++;
			continue;
		}

		/* try to expand the variable to a constant */
		if ((over = get_pv_cnt((const char *)original, &pv_val)) == 0) {
			original++;
			current++;
			continue;
		}

		if (pv_val.flags & PV_VAL_NONE || pv_val.flags & PV_VAL_NULL) {
			/* the pv constant was not found - add '' */
			memcpy(p, last, current);
			p += current;
			current  = 0;
			original = last = over;
			continue;
		}
		/* copy the current non pv constant information */
		memcpy(p, last, current);
		p += current;
		current  = 0;
		original = last = over;

		/* we have a new constant to add */
		if (! (pv_val.flags & PV_VAL_STR)) {
			/* an integer value */
			p += sprintf(p, "%d", pv_val.ri);
		} else {
			/* string value */
			memcpy(p, pv_val.rs.s, pv_val.rs.len);
			p += pv_val.rs.len; *p = '\0';
		}
	} while (*original);

	/* copy the last part if needed */
	if (p != max_expanded) {
		/* a constant expanssion was made */
		memcpy(p, last, current);
		*(p + current) = '\0';
		*expanded = max_expanded;
		return 1;
	}

	return 0;
} /* expand_cnt }}} */
